searchNodes=[{"doc":"ScraperEx This library exists to make scraping a bit easier for business use cases Installation Available in Hex , the package can be installed by adding scraper_ex to your list of dependencies in mix.exs : def deps do [ { :scraper_ex , &quot;~&gt; 0.1.0&quot; } ] end The docs can be found at https://hexdocs.pm/scraper_ex . Usage ScraperEx uses Hound under the hood, which means you can configure hound to use any browser/runner you'd like. By default we use chrome_headless ScraperEx.Window This module exists to manage windows with Hound. Hounds window management by default doesn't help very much with session management, which leads to zombie windows hanging around and can really start to eat up memory. To avoid this we can use ScraperEx.Window to run and interact with a individual session ScraperEx The two useful functions in here are ScraperEx.run_task_in_window and ScraperEx.run_task , run task allows you to input various steps for a scraper while run_in_window will also start a window for you, the bare version won't and you will need to manage your own ScraperEx.Window Tasks Tasks (Flows) are defined by configs, you can either use the struct form using ScraperEx.Task.Config modules or use the short forms The following actions are currently implemented: :navigate_to or ScraperEx.Task.Config.Navigate :input or ScraperEx.Task.Config.Input :click or ScraperEx.Task.Config.Click :read or ScraperEx.Task.Config.Read :screenshot or ScraperEx.Task.Config.Screenshot :scroll or ScraperEx.Task.Config.Scroll :sleep or ScraperEx.Task.Config.Sleep :send_text or ScraperEx.Task.Config.SendText :send_keys or ScraperEx.Task.Config.SendKeys :javascript or ScraperEx.Task.Config.Javascript You can allow errors by wrapping a command in ScraperEx . allow_error ( { :click , { :css , &quot;.thing&quot; } } ) Example iex&gt; ScraperEx . run_task_in_window ( [ ...&gt; { :navigate_to , &quot;https://en.wikipedia.org/wiki/Example.com&quot; } , ...&gt; { :read , :references , { :css , &quot;.reference-text&quot; } } , ...&gt; { :read , :page_title , { :id , &quot;firstHeading&quot; } } , ...&gt; { :read , :external_link_4 , { :css , &quot;#bodyContent ul:nth-child(21) li:nth-child(4)&quot; } } , ...&gt; { :click , { :css , &quot;h2:has(#External_links) + ul li:nth-of-type(3) a&quot; } , :timer . seconds ( 1 ) } , ...&gt; { :read , :clicked_url , { :css , &quot;h1&quot; } } , ...&gt; ] ) { :ok , %{ \\ page_title : &quot;example.com&quot; , \\ external_link_4 : &quot;example.edu&quot; , \\ clicked_url : &quot;Example Domain&quot; , \\ references : [ \\ &quot; \\&quot; IANA WHOIS Service \\&quot; . IANA. Retrieved 2022-10-25.&quot; , \\ &quot; \\&quot; IANA-managed Reserved Domains \\&quot; . IANA. Retrieved 2020-06-20.&quot; , \\ &quot;RFC 2606, Reserved Top Level DNS Names, D. Eastlake, A. Panitz, The Internet Society (June 1999), Section 3.&quot; , \\ &quot;RFC 6761, S. Cheshire, M. Krochmal, Special-Use Domain Names, IETF (February 2013)&quot; \\ ] \\ } } Testing We can test and mock out specific flow responses by using ScraperEx.Sandbox First we must call ScraperEx.Sandbox.start_link() in our test_helpers.ex file, then Inside our test, we can do ScraperEx.Sandbox . set_run_task_result ( my_flow ( ) , %{ my_result : :ok } ) in each test to set the response of a specific flow.","ref":"ScraperEx.html","title":"ScraperEx","type":"module"},{"doc":"","ref":"ScraperEx.html#allow_error/1","title":"ScraperEx.allow_error/1","type":"function"},{"doc":"This function allows you to run a task within a window you control, good for times where you have a long running window you need to run multiple tasks on Example iex&gt; Hound . start_session ( ) iex&gt; ScraperEx . run_task ( [ ...&gt; { :navigate_to , &quot;https://example.com/&quot; , :timer . seconds ( 1 ) } , ...&gt; { :click , { :css , &quot;a&quot; } , :timer . seconds ( 1 ) } , ...&gt; { :read , :page_title , { :css , &quot;h1&quot; } } , ...&gt; ] ) { :ok , %{ page_title : &quot;IANA-managed Reserved Domains&quot; } } iex&gt; Hound . end_session ( )","ref":"ScraperEx.html#run_task/2","title":"ScraperEx.run_task/2","type":"function"},{"doc":"This function allows you to run a task and a window is started for you, good for times where you have a short running task to open and close a web page Example iex&gt; ScraperEx . run_task_in_window ( [ ...&gt; { :navigate_to , &quot;https://example.com/&quot; , :timer . seconds ( 1 ) } , ...&gt; { :click , { :css , &quot;a&quot; } , :timer . seconds ( 1 ) } , ...&gt; { :read , :page_title , { :css , &quot;h1&quot; } } , ...&gt; ] ) { :ok , %{ page_title : &quot;IANA-managed Reserved Domains&quot; } }","ref":"ScraperEx.html#run_task_in_window/2","title":"ScraperEx.run_task_in_window/2","type":"function"},{"doc":"","ref":"ScraperEx.html#t:task_atom_config/0","title":"ScraperEx.task_atom_config/0","type":"type"},{"doc":"","ref":"ScraperEx.html#t:task_config/0","title":"ScraperEx.task_config/0","type":"type"},{"doc":"","ref":"ScraperEx.html#t:task_module_config/0","title":"ScraperEx.task_module_config/0","type":"type"},{"doc":"","ref":"ScraperEx.html#t:task_opts/0","title":"ScraperEx.task_opts/0","type":"type"},{"doc":"","ref":"ScraperEx.html#t:window_opts/0","title":"ScraperEx.window_opts/0","type":"type"},{"doc":"Sandboxing allows you to set the return value of a specific flow ScraperEx.Sandbox . set_run_task_result ( my_flow ( ) , %{ my_result : :ok } )","ref":"ScraperEx.Sandbox.html","title":"ScraperEx.Sandbox","type":"module"},{"doc":"Gets the results for a flow","ref":"ScraperEx.Sandbox.html#run_task_result/1","title":"ScraperEx.Sandbox.run_task_result/1","type":"function"},{"doc":"Sets the result for a flow","ref":"ScraperEx.Sandbox.html#set_run_task_result/2","title":"ScraperEx.Sandbox.set_run_task_result/2","type":"function"},{"doc":"","ref":"ScraperEx.Sandbox.html#start_link/0","title":"ScraperEx.Sandbox.start_link/0","type":"function"},{"doc":"","ref":"ScraperEx.Task.Config.html","title":"ScraperEx.Task.Config","type":"module"},{"doc":"This module exists to manage Hound sessions. One session is started per window and you can run functions on this window. To start multiple windows you create multiple of these processes. Example import Hound.Helpers { :ok , pid } = ScraperEx.Window . start_link ( ) ScraperEx.Window . run_in_window ( pid , fn session_id -&gt; navigate_to ( &quot;https://mysite.com&quot; ) fill_field ( { :css , &quot;.selector&quot; } , &quot;Hello World&quot; ) end )","ref":"ScraperEx.Window.html","title":"ScraperEx.Window","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ScraperEx.Window.html#child_spec/1","title":"ScraperEx.Window.child_spec/1","type":"function"},{"doc":"","ref":"ScraperEx.Window.html#close_and_reopen_window/1","title":"ScraperEx.Window.close_and_reopen_window/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"ScraperEx.Window.html#handle_continue/2","title":"ScraperEx.Window.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ScraperEx.Window.html#init/1","title":"ScraperEx.Window.init/1","type":"function"},{"doc":"","ref":"ScraperEx.Window.html#run_in_window/2","title":"ScraperEx.Window.run_in_window/2","type":"function"},{"doc":"","ref":"ScraperEx.Window.html#shutdown/1","title":"ScraperEx.Window.shutdown/1","type":"function"},{"doc":"","ref":"ScraperEx.Window.html#start_link/1","title":"ScraperEx.Window.start_link/1","type":"function"},{"doc":"Clicks a element on the page","ref":"ScraperEx.Task.Config.Click.html","title":"ScraperEx.Task.Config.Click","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Click.html#t:t/0","title":"ScraperEx.Task.Config.Click.t/0","type":"type"},{"doc":"Inputs text into a input","ref":"ScraperEx.Task.Config.Input.html","title":"ScraperEx.Task.Config.Input","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Input.html#t:t/0","title":"ScraperEx.Task.Config.Input.t/0","type":"type"},{"doc":"Runs a JS function, if key is specified the return results make it back on the end map","ref":"ScraperEx.Task.Config.Javascript.html","title":"ScraperEx.Task.Config.Javascript","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Javascript.html#t:t/0","title":"ScraperEx.Task.Config.Javascript.t/0","type":"type"},{"doc":"Navigates to a page, can specify load_time","ref":"ScraperEx.Task.Config.Navigate.html","title":"ScraperEx.Task.Config.Navigate","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Navigate.html#t:t/0","title":"ScraperEx.Task.Config.Navigate.t/0","type":"type"},{"doc":"Reads a value from the page and stores it under a key, this key will be used to build a map with all the read values","ref":"ScraperEx.Task.Config.Read.html","title":"ScraperEx.Task.Config.Read","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Read.html#t:t/0","title":"ScraperEx.Task.Config.Read.t/0","type":"type"},{"doc":"Takes a screenshot","ref":"ScraperEx.Task.Config.Screenshot.html","title":"ScraperEx.Task.Config.Screenshot","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Screenshot.html#t:t/0","title":"ScraperEx.Task.Config.Screenshot.t/0","type":"type"},{"doc":"Scrolls an element","ref":"ScraperEx.Task.Config.Scroll.html","title":"ScraperEx.Task.Config.Scroll","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Scroll.html#t:t/0","title":"ScraperEx.Task.Config.Scroll.t/0","type":"type"},{"doc":"Sends amount of keys defined by &amp;Hound.Helpers.Page.send_keys/1","ref":"ScraperEx.Task.Config.SendKeys.html","title":"ScraperEx.Task.Config.SendKeys","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.SendKeys.html#t:t/0","title":"ScraperEx.Task.Config.SendKeys.t/0","type":"type"},{"doc":"Sleep for x period","ref":"ScraperEx.Task.Config.SendText.html","title":"ScraperEx.Task.Config.SendText","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.SendText.html#t:t/0","title":"ScraperEx.Task.Config.SendText.t/0","type":"type"},{"doc":"Sleep for x period","ref":"ScraperEx.Task.Config.Sleep.html","title":"ScraperEx.Task.Config.Sleep","type":"module"},{"doc":"","ref":"ScraperEx.Task.Config.Sleep.html#t:t/0","title":"ScraperEx.Task.Config.Sleep.t/0","type":"type"}]